Index: trunk/src/org/openstreetmap/josm/gui/ExtendedDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/ExtendedDialog.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/ExtendedDialog.java	(revision 2025)
@@ -3,4 +3,5 @@
 import java.awt.Component;
 import java.awt.Dimension;
+import java.awt.Frame;
 import java.awt.GridBagLayout;
 import java.awt.Toolkit;
@@ -202,5 +203,5 @@
         super.setVisible(visible);
         if (visible) {
-            toFront();
+            repaint();
         }
     }
Index: trunk/src/org/openstreetmap/josm/gui/MainApplication.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/MainApplication.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/MainApplication.java	(revision 2025)
@@ -47,5 +47,5 @@
         mainFrame.addWindowListener(new WindowAdapter(){
             @Override public void windowClosing(final WindowEvent arg0) {
-                if (Main.breakBecauseUnsavedChanges())
+                if (!Main.saveUnsavedModifications())
                     return;
                 Main.saveGuiGeometry();
@@ -73,12 +73,14 @@
         final Map<String, Collection<String>> args = new HashMap<String, Collection<String>>();
         for (String arg : argArray) {
-            if (!arg.startsWith("--"))
+            if (!arg.startsWith("--")) {
                 arg = "--download="+arg;
+            }
             int i = arg.indexOf('=');
             String key = i == -1 ? arg.substring(2) : arg.substring(2,i);
             String value = i == -1 ? "" : arg.substring(i+1);
             Collection<String> v = args.get(key);
-            if (v == null)
+            if (v == null) {
                 v = new LinkedList<String>();
+            }
             v.add(value);
             args.put(key, v);
@@ -88,8 +90,9 @@
 
         // Check if passed as parameter
-        if (args.containsKey("language"))
+        if (args.containsKey("language")) {
             I18n.set((String)(args.get("language").toArray()[0]));
-        else
+        } else {
             I18n.set(Main.pref.get("language", null));
+        }
 
         if (argList.contains("--help") || argList.contains("-?") || argList.contains("-h")) {
@@ -143,7 +146,8 @@
 
         if (((!args.containsKey("no-maximize") && !args.containsKey("geometry")
-        && Main.pref.get("gui.geometry").length() == 0) || args.containsKey("maximize"))
-        && Toolkit.getDefaultToolkit().isFrameStateSupported(JFrame.MAXIMIZED_BOTH))
+                && Main.pref.get("gui.geometry").length() == 0) || args.containsKey("maximize"))
+                && Toolkit.getDefaultToolkit().isFrameStateSupported(JFrame.MAXIMIZED_BOTH)) {
             mainFrame.setExtendedState(JFrame.MAXIMIZED_BOTH);
+        }
 
         EventQueue.invokeLater(new Runnable() {
@@ -161,11 +165,13 @@
     public static void removeObsoletePreferences() {
         String[] obsolete = {
-           "sample.preference.that.does.not.exist", // sample comment, expiry date should go here
-           "osm-server.version", // remove this around 10/2009
-           "osm-server.additional-versions", // remove this around 10/2009
-           null
+                "sample.preference.that.does.not.exist", // sample comment, expiry date should go here
+                "osm-server.version", // remove this around 10/2009
+                "osm-server.additional-versions", // remove this around 10/2009
+                null
         };
         for (String i : obsolete) {
-            if (i == null) continue;
+            if (i == null) {
+                continue;
+            }
             if (Main.pref.hasKey(i)) {
                 Main.pref.removeFromCollection(i, Main.pref.get(i));
Index: trunk/src/org/openstreetmap/josm/gui/MapStatus.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/MapStatus.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/MapStatus.java	(revision 2025)
@@ -194,10 +194,10 @@
                             final StringBuilder text = new StringBuilder();
                             String name = osm.getDisplayName(DefaultNameFormatter.getInstance());
-                            if (osm.id == 0 || osm.modified) {
+                            if (osm.getId() == 0 || osm.isModified()) {
                                 name = "<i><b>"+ osm.getDisplayName(DefaultNameFormatter.getInstance())+"*</b></i>";
                             }
                             text.append(name);
-                            if (osm.id != 0) {
-                                text.append("<br>id="+osm.id);
+                            if (osm.getId() != 0) {
+                                text.append("<br>id="+osm.getId());
                             }
                             for (Entry<String, String> e : osm.entrySet()) {
Index: trunk/src/org/openstreetmap/josm/gui/MapView.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/MapView.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/MapView.java	(revision 2025)
@@ -44,5 +44,4 @@
 import org.openstreetmap.josm.gui.layer.MapViewPaintable;
 import org.openstreetmap.josm.gui.layer.OsmDataLayer;
-import org.openstreetmap.josm.gui.layer.OsmDataLayer.ModifiedChangedListener;
 import org.openstreetmap.josm.gui.layer.markerlayer.MarkerLayer;
 import org.openstreetmap.josm.gui.layer.markerlayer.PlayHeadMarker;
@@ -152,13 +151,4 @@
      */
     public void addLayer(Layer layer) {
-        if (layer instanceof OsmDataLayer) {
-            OsmDataLayer editLayer = (OsmDataLayer)layer;
-            editLayer.listenerModified.add(new ModifiedChangedListener(){
-                public void modifiedChanged(boolean value, OsmDataLayer source) {
-                    JOptionPane.getFrameForComponent(Main.parent).setTitle((value?"*":"")
-                            +tr("Java OpenStreetMap Editor"));
-                }
-            });
-        }
         if (layer instanceof MarkerLayer && playHeadMarker == null) {
             playHeadMarker = PlayHeadMarker.create();
@@ -510,4 +500,7 @@
             }
         }
+        if (layer instanceof OsmDataLayer) {
+            refreshTitle((OsmDataLayer)layer);
+        }
 
         /* This only makes the buttons look disabled. Disabling the actions as well requires
@@ -600,4 +593,19 @@
         if (evt.getPropertyName().equals(Layer.VISIBLE_PROP)) {
             repaint();
+        } else if (evt.getPropertyName().equals(OsmDataLayer.REQUIRES_SAVE_TO_DISK_PROP)
+                || evt.getPropertyName().equals(OsmDataLayer.REQUIRES_UPLOAD_TO_SERVER_PROP)) {
+            OsmDataLayer layer = (OsmDataLayer)evt.getSource();
+            if (layer == getEditLayer()) {
+                refreshTitle(layer);
+            }
+        }
+    }
+
+    protected void refreshTitle(OsmDataLayer layer) {
+        boolean dirty = layer.requiresSaveToFile() || layer.requiresUploadToServer();
+        if (dirty) {
+            JOptionPane.getFrameForComponent(Main.parent).setTitle("* " + tr("Java OpenStreetMap Editor"));
+        } else {
+            JOptionPane.getFrameForComponent(Main.parent).setTitle(tr("Java OpenStreetMap Editor"));
         }
     }
Index: trunk/src/org/openstreetmap/josm/gui/NavigatableComponent.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/NavigatableComponent.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/NavigatableComponent.java	(revision 2025)
@@ -74,5 +74,5 @@
         double dist = getDist100Pixel();
         return dist >= 2000 ? Math.round(dist/100)/10 +" km" : (dist >= 1
-        ? Math.round(dist*10)/10 +" m" : "< 1 m");
+                ? Math.round(dist*10)/10 +" m" : "< 1 m");
     }
 
@@ -112,7 +112,7 @@
                         center.east() - getWidth()/2.0*scale,
                         center.north() - getHeight()/2.0*scale),
-                new EastNorth(
-                        center.east() + getWidth()/2.0*scale,
-                        center.north() + getHeight()/2.0*scale));
+                        new EastNorth(
+                                center.east() + getWidth()/2.0*scale,
+                                center.north() + getHeight()/2.0*scale));
     };
 
@@ -121,5 +121,5 @@
         Bounds b = getProjection().getWorldBoundsLatLon();
         return new ProjectionBounds(getProjection().latlon2eastNorth(b.min),
-            getProjection().latlon2eastNorth(b.max));
+                getProjection().latlon2eastNorth(b.max));
     };
 
@@ -130,7 +130,7 @@
                         center.east() - getWidth()/2.0*scale,
                         center.north() - getHeight()/2.0*scale)),
-                getProjection().eastNorth2latlon(new EastNorth(
-                        center.east() + getWidth()/2.0*scale,
-                        center.north() + getHeight()/2.0*scale)));
+                        getProjection().eastNorth2latlon(new EastNorth(
+                                center.east() + getWidth()/2.0*scale,
+                                center.north() + getHeight()/2.0*scale)));
     };
 
@@ -189,6 +189,7 @@
         if(lon < b.min.lon()) {changed = true; lon = b.min.lon(); }
         else if(lon > b.max.lon()) {changed = true; lon = b.max.lon(); }
-        if(changed)
-          newCenter = new CachedLatLon(lat, lon).getEastNorth();
+        if(changed) {
+            newCenter = new CachedLatLon(lat, lon).getEastNorth();
+        }
         if (!newCenter.equals(center)) {
             EastNorth oldCenter = center;
@@ -211,12 +212,14 @@
             e2 = getProjection().latlon2eastNorth(new LatLon(lat, b.max.lon()));
             d = e2.east() - e1.east();
-            if(d < width*newScale)
+            if(d < width*newScale) {
                 newScale = Math.max(newScaleH, d/width);
+            }
         }
         else
         {
             d = d/(l1.greatCircleDistance(l2)*height*10);
-            if(newScale < d)
+            if(newScale < d) {
                 newScale = d;
+            }
         }
         if (scale != newScale) {
@@ -296,5 +299,5 @@
             return null;
         for (Node n : ds.nodes) {
-            if (n.deleted || n.incomplete) {
+            if (n.isDeleted() || n.incomplete) {
                 continue;
             }
@@ -307,6 +310,6 @@
             // when multiple nodes on one point, prefer new or selected nodes
             else if(dist == minDistanceSq && minPrimitive != null
-                    && ((n.id == 0 && n.isSelected())
-                            || (!minPrimitive.isSelected() && (n.isSelected() || n.id == 0)))) {
+                    && ((n.getId() == 0 && n.isSelected())
+                            || (!minPrimitive.isSelected() && (n.isSelected() || n.getId() == 0)))) {
                 minPrimitive = n;
             }
@@ -327,5 +330,5 @@
             return null;
         for (Way w : ds.ways) {
-            if (w.deleted || w.incomplete) {
+            if (w.isDeleted() || w.incomplete) {
                 continue;
             }
@@ -334,5 +337,5 @@
             for (Node n : w.getNodes()) {
                 i++;
-                if (n.deleted || n.incomplete) {
+                if (n.isDeleted() || n.incomplete) {
                     continue;
                 }
@@ -451,10 +454,10 @@
             return null;
         for (Way w : ds.ways) {
-            if (w.deleted || w.incomplete) {
+            if (w.isDeleted() || w.incomplete) {
                 continue;
             }
             Node lastN = null;
             for (Node n : w.getNodes()) {
-                if (n.deleted || n.incomplete) {
+                if (n.isDeleted() || n.incomplete) {
                     continue;
                 }
@@ -477,5 +480,5 @@
         }
         for (Node n : ds.nodes) {
-            if (!n.deleted && !n.incomplete
+            if (!n.isDeleted() && !n.incomplete
                     && getPoint(n).distanceSq(p) < snapDistance) {
                 nearest.add(n);
@@ -499,5 +502,5 @@
             return null;
         for (Node n : ds.nodes) {
-            if (!n.deleted && !n.incomplete
+            if (!n.isDeleted() && !n.incomplete
                     && getPoint(n).distanceSq(p) < snapDistance) {
                 nearest.add(n);
Index: trunk/src/org/openstreetmap/josm/gui/PleaseWaitRunnable.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/PleaseWaitRunnable.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/PleaseWaitRunnable.java	(revision 2025)
@@ -45,10 +45,10 @@
      */
     public PleaseWaitRunnable(String title, boolean ignoreException) {
-        this(title, new PleaseWaitProgressMonitor(), ignoreException);
+        this(title, new PleaseWaitProgressMonitor(title), ignoreException);
     }
 
     public PleaseWaitRunnable(String title, ProgressMonitor progressMonitor, boolean ignoreException) {
         this.title = title;
-        this.progressMonitor = progressMonitor == null?new PleaseWaitProgressMonitor():progressMonitor;
+        this.progressMonitor = progressMonitor == null?new PleaseWaitProgressMonitor(title):progressMonitor;
         this.ignoreException = ignoreException;
         this.progressMonitor.addCancelListener(this);
Index: trunk/src/org/openstreetmap/josm/gui/SelectionManager.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/SelectionManager.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/SelectionManager.java	(revision 2025)
@@ -286,5 +286,5 @@
             // nodes
             for (Node n : nc.getCurrentDataSet().nodes) {
-                if (!n.deleted && !n.incomplete && r.contains(nc.getPoint(n))) {
+                if (!n.isDeleted() && !n.incomplete && r.contains(nc.getPoint(n))) {
                     selection.add(n);
                 }
@@ -293,5 +293,5 @@
             // ways
             for (Way w : nc.getCurrentDataSet().ways) {
-                if (w.deleted || w.getNodesCount() == 0 || w.incomplete) {
+                if (w.isDeleted() || w.getNodesCount() == 0 || w.incomplete) {
                     continue;
                 }
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/LayerListDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/LayerListDialog.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/LayerListDialog.java	(revision 2025)
@@ -47,4 +47,5 @@
 import org.openstreetmap.josm.gui.MapView;
 import org.openstreetmap.josm.gui.SideButton;
+import org.openstreetmap.josm.gui.io.SaveLayersDialog;
 import org.openstreetmap.josm.gui.layer.Layer;
 import org.openstreetmap.josm.gui.layer.OsmDataLayer;
@@ -299,113 +300,42 @@
         }
 
-        protected boolean confirmSkipSaving(OsmDataLayer layer) {
-            int result = new ExtendedDialog(Main.parent,
-                    tr("Unsaved Changes"),
-                    tr("There are unsaved changes in the layer''{0}''. Delete the layer anwyay?",layer.getName()),
-                    new String[] {tr("Delete Layer"), tr("Cancel")},
-                    new String[] {"dialogs/delete.png", "cancel.png"}).getValue();
-
-            return result == 1;
-        }
-
-        protected boolean confirmDeleteLayer(Layer layer) {
-            return ConditionalOptionPaneUtil.showConfirmationDialog(
-                    "delete_layer",
-                    Main.parent,
-                    tr("Do you really want to delete layer ''{0}''?", layer.getName()),
-                    tr("Confirmation"),
-                    JOptionPane.YES_NO_OPTION,
-                    JOptionPane.QUESTION_MESSAGE,
-                    JOptionPane.YES_OPTION);
-        }
-
-        protected DeleteDecision confirmDeleteMultipleLayer(Layer layer, int idx, int numLayers) {
-            String options[] = new String[] {
-                    tr("Yes"),
-                    tr("No"),
-                    tr("Delete all"),
-                    tr("Cancel")
-            };
-            int ret = ConditionalOptionPaneUtil.showOptionDialog(
-                    "delete_layer",
-                    Main.parent,
-                    tr("Do you really want to delete layer ''{0}''?", layer.getName()),
-                    tr("Deleting layer {0} of {1}", idx+1, numLayers),
-                    JOptionPane.DEFAULT_OPTION,
-                    JOptionPane.QUESTION_MESSAGE,
-                    options,
-                    options[0]
-            );
-            switch(ret) {
-                case ConditionalOptionPaneUtil.DIALOG_DISABLED_OPTION: return DeleteDecision.deleteAll;
-                case JOptionPane.CLOSED_OPTION: return DeleteDecision.cancel;
-                case 0: return DeleteDecision.deleteCurrent;
-                case 1: return DeleteDecision.dontDeleteCurrent;
-                case 2: return DeleteDecision.deleteAll;
-                case 3: return DeleteDecision.cancel;
-                default:
-                    // shouldn't happen. This is the safest option.
-                    return DeleteDecision.cancel;
-            }
-        }
-
-
-        public void deleteSingleLayer(Layer layer) {
-            if (layer == null)
+        protected boolean enforceUploadOrSaveModifiedData(List<Layer> selectedLayers) {
+            SaveLayersDialog dialog = new SaveLayersDialog(Main.parent);
+            List<OsmDataLayer> layersWithUnmodifiedChanges = new ArrayList<OsmDataLayer>();
+            for (Layer l: selectedLayers) {
+                if (! (l instanceof OsmDataLayer)) {
+                    continue;
+                }
+                OsmDataLayer odl = (OsmDataLayer)l;
+                if (odl.requiresSaveToFile() || odl.requiresUploadToServer()) {
+                    layersWithUnmodifiedChanges.add(odl);
+                }
+            }
+            dialog.prepareForSavingAndUpdatingLayersBeforeDelete();
+            if (!layersWithUnmodifiedChanges.isEmpty()) {
+                dialog.getModel().populate(layersWithUnmodifiedChanges);
+                dialog.setVisible(true);
+                switch(dialog.getUserAction()) {
+                    case CANCEL: return false;
+                    case PROCEED: return true;
+                    default: return false;
+                }
+            }
+            return true;
+        }
+
+        public void actionPerformed(ActionEvent e) {
+            List<Layer> selectedLayers;
+            if (this.layer == null) {
+                selectedLayers = getModel().getSelectedLayers();
+            } else {
+                selectedLayers = Collections.singletonList(this.layer);
+            }
+            if (selectedLayers.isEmpty())
                 return;
-            if (layer instanceof OsmDataLayer) {
-                OsmDataLayer dataLayer = (OsmDataLayer)layer;
-                if (dataLayer.isModified()) {
-                    if (! confirmSkipSaving(dataLayer))
-                        return;
-                }
-                else if (!confirmDeleteLayer(dataLayer))
-                    return;
-            } else {
-                if (!confirmDeleteLayer(layer))
-                    return;
-            }
-            // model and view are going to be updated via LayerChangeListener
-            //
-            Main.main.removeLayer(layer);
-        }
-
-        public void deleteMultipleLayers(List<Layer> layers) {
-            boolean doAskConfirmation = true;
-            for (int i=0; i < layers.size(); i++) {
-                Layer layer = layers.get(i);
-                if (layer instanceof OsmDataLayer) {
-                    OsmDataLayer dataLayer = (OsmDataLayer)layer;
-                    if (dataLayer.isModified() && ! confirmSkipSaving(dataLayer)) {
-                        continue;
-                    }
-                }
-                if (doAskConfirmation) {
-                    DeleteDecision decision = confirmDeleteMultipleLayer(layer, i, layers.size());
-                    switch(decision) {
-                        case deleteCurrent: /* do nothing */ break;
-                        case deleteAll: doAskConfirmation = false; break;
-                        case dontDeleteCurrent: continue;
-                        case cancel: return;
-                    }
-                }
-                // model and view are going to be updated via LayerChangeListener
-                //
-                Main.main.removeLayer(layer);
-            }
-        }
-
-        public void actionPerformed(ActionEvent e) {
-            if (this.layer == null) {
-                List<Layer> selectedLayers = getModel().getSelectedLayers();
-                if (selectedLayers.isEmpty())
-                    return;
-                if (selectedLayers.size() == 1) {
-                    deleteSingleLayer(selectedLayers.get(0));
-                } else {
-                    deleteMultipleLayers(selectedLayers);
-                }
-            } else {
-                deleteSingleLayer(this.layer);
+            if (! enforceUploadOrSaveModifiedData(selectedLayers))
+                return;
+            for(Layer l: selectedLayers) {
+                Main.main.removeLayer(l);
             }
         }
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/RelationListDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/RelationListDialog.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/RelationListDialog.java	(revision 2025)
@@ -135,5 +135,5 @@
             int i = 0;
             for (OsmPrimitive e : DataSet.sort(Main.main.getCurrentDataSet().relations)) {
-                if (!e.deleted && !e.incomplete) {
+                if (!e.isDeleted() && !e.incomplete) {
                     list.setElementAt(e, i++);
                 }
@@ -381,6 +381,8 @@
             Relation copy = new Relation();
             copy.cloneFrom(original);
+            // FIXME: id is going to be hidden. How to reset a primitive?
+            //
             copy.id = 0;
-            copy.modified = true;
+            copy.setModified(true);
             RelationEditor editor = RelationEditor.getEditor(
                     Main.main.getEditLayer(),
Index: trunk/src/org/openstreetmap/josm/gui/dialogs/relation/ReferringRelationsBrowser.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/dialogs/relation/ReferringRelationsBrowser.java	(revision 2021)
+++ trunk/src/org/openstreetmap/josm/gui/dialogs/relation/ReferringRelationsBrowser.java	(revision 2025)
@@ -107,5 +107,5 @@
                     getLayer(),
                     full,
-                    new PleaseWaitProgressMonitor()
+                    new PleaseWaitProgressMonitor(tr("Loading parent relations"))
             );
             task.setContinuation(
Index: trunk/src/org/openstreetmap/josm/gui/io/AbstractIOTask.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/AbstractIOTask.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/AbstractIOTask.java	(revision 2025)
@@ -0,0 +1,96 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+/**
+ * This is an abstract task for uploading or saving a data layer.
+ * 
+ */
+public abstract class AbstractIOTask implements Runnable {
+
+    /** indicates whether the task has been cancelled */
+    private boolean cancelled;
+    /** indicates whether the task has been failed */
+    private boolean failed;
+    /** the last exception caught */
+    private Exception lastException;
+
+    public AbstractIOTask() {
+        cancelled = false;
+        failed = false;
+        lastException = null;
+    }
+
+    /**
+     * Replies true if the task has been cancelled
+     * 
+     * @return true if the task has been cancelled
+     */
+    public boolean isCancelled() {
+        return cancelled;
+    }
+
+    /**
+     * Set whether this task has been cancelled
+     * 
+     * @param cancelled true, if the task has been cancelled; false otherwise
+     */
+    protected void setCancelled(boolean cancelled) {
+        this.cancelled = cancelled;
+    }
+
+    /**
+     * Replies true if the task has been failed
+     * 
+     * @return true if the task has been failed
+     */
+    public boolean isFailed() {
+        return failed || lastException != null;
+    }
+
+    /**
+     * Sets whether the task has been failed
+     * 
+     * @param failed whether the task has been failed
+     */
+    protected void setFailed(boolean failed) {
+        this.failed = failed;
+    }
+
+    /**
+     * Replies the last exception caught
+     * 
+     * @return the last exception caught; null, if no exception was caught
+     */
+    public Exception getLastException() {
+        return lastException;
+    }
+
+    /**
+     * Sets the last exception caught
+     * 
+     * @param lastException the last exception
+     */
+    protected void setLastException(Exception lastException) {
+        this.lastException = lastException;
+    }
+
+    /**
+     * Replies true if this  task was successful, i.e. if it wasn't
+     * cancelled and didn't fail
+     * 
+     * @return true if this  task was successful
+     */
+    public boolean isSuccessful() {
+        return !isCancelled() && !isFailed();
+    }
+
+    /**
+     * Runs the task
+     */
+    public abstract void run();
+
+    /**
+     * Cancel the task
+     */
+    public abstract void cancel();
+}
Index: trunk/src/org/openstreetmap/josm/gui/io/FilenameCellEditor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/io/FilenameCellEditor.java	(revision 2025)
+++ trunk/src/org/openstreetmap/josm/gui/io/FilenameCellEditor.java	(revision 2025)
@@ -0,0 +1,155 @@
+// License: GPL. For details, see LICENSE file.
+package org.openstreetmap.josm.gui.io;
+
+import static org.openstreetmap.josm.tools.I18n.tr;
+
+import java.awt.Component;
+import java.awt.GridBagConstraints;
+import java.awt.GridBagLayout;
+import java.awt.event.ActionEvent;
+import java.awt.event.FocusAdapter;
+import java.awt.event.FocusEvent;
+import java.io.File;
+import java.util.EventObject;
+import java.util.concurrent.CopyOnWriteArrayList;
+
+import javax.swing.AbstractAction;
+import javax.swing.JButton;
+import javax.swing.JPanel;
+import javax.swing.JTable;
+import javax.swing.JTextField;
+import javax.swing.event.CellEditorListener;
+import javax.swing.event.ChangeEvent;
+import javax.swing.table.TableCellEditor;
+
+import org.openstreetmap.josm.actions.SaveActionBase;
+
+/**
+ * This is a {@see TableCellEditor} for filenames. It provides a text input field and
+ * a button for launchinig a {@see JFileChooser}.
+ * 
+ *
+ */
+class FilenameCellEditor extends JPanel implements TableCellEditor {
+    private JTextField tfFileName;
+    private CopyOnWriteArrayList<CellEditorListener> listeners;
+    private File value;
+
+    /**
+     * build the GUI
+     */
+    protected void build() {
+        setLayout(new GridBagLayout());
+        GridBagConstraints gc = new GridBagConstraints();
+        gc.gridx = 0;
+        gc.gridy = 0;
+        gc.fill = GridBagConstraints.BOTH;
+        gc.weightx = 1.0;
+        gc.weighty = 1.0;
+        add(tfFileName = new JTextField(), gc);
+
+
+        gc.gridx = 1;
+        gc.gridy = 0;
+        gc.fill = GridBagConstraints.BOTH;
+        gc.weightx = 0.0;
+        gc.weighty = 1.0;
+        add(new JButton(new LaunchFileChooserAction()));
+
+        tfFileName.addFocusListener(
+                new FocusAdapter() {
+                    @Override
+                    public void focusGained(FocusEvent e) {
+                        tfFileName.selectAll();
+                    }
+                }
+        );
+    }
+
+    public FilenameCellEditor() {
+        listeners = new CopyOnWriteArrayList<CellEditorListener>();
+        build();
+    }
+
+
+    public void addCellEditorListener(CellEditorListener l) {
+        if (!listeners.contains(l)) {
+            listeners.add(l);
+        }
+    }
+
+    protected void fireEditingCanceled() {
+        for (CellEditorListener l: listeners) {
+            l.editingCanceled(new ChangeEvent(this));
+        }
+    }
+
+    protected void fireEditingStopped() {
+        for (CellEditorListener l: listeners) {
+            l.editingStopped(new ChangeEvent(this));
+        }
+    }
+
+    public void cancelCellEditing() {
+        fireEditingCanceled();
+    }
+
+    public Object getCellEditorValue() {
+        return value;
+    }
+
+    public boolean isCellEditable(EventObject anEvent) {
+        return true;
+    }
+
+    public void removeCellEditorListener(CellEditorListener l) {
+        if (listeners.contains(l)) {
+            listeners.remove(l);
+        }
+    }
+
+    public boolean shouldSelectCell(EventObject anEvent) {
+        return true;
+    }
+
+    public boolean stopCellEditing() {
+        if (tfFileName.getText() == null || tfFileName.getText().trim().equals("")) {
+            value = null;
+        } else {
+            value = new File(tfFileName.getText());
+        }
+        fireEditingStopped();
+        return true;
+    }
+
+    public void setInitialValue(File initialValue) {
+        this.value = initialValue;
+        if (initialValue == null) {
+            this.tfFileName.setText("");
+        } else {
+            this.tfFileName.setText(initialValue.toString());
+        }
+    }
+
+    public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
+        SaveLayerInfo info = (SaveLayerInfo)value;
+        setInitialValue(info.getFile());
+        tfFileName.selectAll();
+        return this;
+    }
+
+    class LaunchFileChooserAction extends AbstractAction {
+        public LaunchFileChooserAction() {
+            putValue(NAME, "...");
+            putValue(SHORT_DESCRIPTION, tr("Launch a file chooser to select a file"));
+        }
+
+        public void actionPerformed(ActionEvent e) {
+            File f = SaveActionBase.createAndOpenSaveFileChooser(tr("Select filename"), "osm");
+            if (f != null) {
+                FilenameCellEditor.this.tfFileName.setText(f.toString());
+                FilenameCellEditor.this.tfFileName.selectAll();
+            }
+        }
+    }
+}
